;***Constants****************************************************************
SizeofObjectS	=	20
SizeofPolyS	=	44
SizeofPolyQ	=	32
SizeofPointS	=	6
zadd		=	512
zshift		=	9
TopoWidth	=	640*3
Clear		=	0821h

SEEKBEG		=	0
SEEKCUR		=	1
SEEKEND		=	2
R		=	0
W		=	1
RW		=	2
;***Macros*******************************************************************

s macro
	mov bx,0A123h
	mov es,bx
ENDM

sa macro
	mov ax,0A123h
	mov es,ax
ENDM

beep macro
		mov ax,0E07h
		int 10h
ENDM

clrscrbfr macro
	mov edi,0		;get address of screen buffer
	mov dx,[ScreenBuffer]
	push es
	mov es,dx
	mov ecx,25800h		;move 1/2 of the number of dwords of screen
	mov eax,[background]	;move color to background
	cld			;make sure we're in the right direction
   rep	stosd			;repeat for 1st half of screen

	mov ax,fs
	mov edi,[zbuffer]
	mov es,ax
	mov ecx,25900h		;size of zbuffer
	mov eax,75307530h	;almost as low as it can go (2 words)
   rep  stosd

	pop es
ENDM

FlushSBuffer macro ;proc
local FlushLoop
		push es
		xor esi,esi
		push ds
		mov ax,[VideoSelector]
		mov bx,[ScreenBuffer]
		mov es,ax		;load video selector
		mov ds,bx
		xor edx,edx		;clear bankswitch
		xor ebx,ebx
		xor eax,eax

 FlushLoop:	mov cl,cs:[BankShift]
		push edx
		shl edx,cl		;calculate bank shift
		push eax
		mov ax,4f05h
		int 10h			;call vesa bank switch

		xor edi,edi		;start at beginning of screen
		mov ecx,4000h		;loop this many times (DW = 4 B)
	rep	movsd			;flush screen buffer

		pop eax
		pop edx
		inc eax
		inc edx
		cmp eax,10
		jb cs:FlushLoop

		pop ds
		pop es
ENDM


;***Structures***************************************************************
;Indirection Syntax
;   mov [(PosValType bx).Pos.Row], ax
;                      ; OK: Move AX to Row component of PosValType instance
;                      ; pointed to by BX

Polygon struc
	x1		dw	(?)	;points of surrounding rectangle
	y1		dw	(?)
	z1		dw	(?)
	x2		dw	(?)
	y2		dw	(?)
	z2		dw	(?)
	x3		dw	(?)
	y3		dw	(?)
	z3		dw	(?)
	x4		dw	(?)
	y4		dw	(?)
	z4		dw	(?)

	normx		dw	(?)
	normy		dw	(?)
	normz		dw	(?)

	numlpix		dw	(?)	;number of pixels long
	numhpix		dw	(?)	;number of pixels high

	ToMap		dd	(?)	;pointer to array of bytes
					;(Texture Map)
	Flags		db	(?)	;See doc.txt
	NumPoints 	db	(?)	;number of points in polygon
					;(anti-a & hit detection)
	ToPoints  	dd	(?)	;pointer to array of points
					;listed as above (x1,y1,z1,x2, ...)
ENDS
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Points struc
	x		dw	(?)	;points of surrounding rectangle
	y		dw	(?)
	z		dw	(?)
ENDS
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Object struc
	Tolerance	dd	(?)	;distance from center to outermost
					;point: used for seeing when need
					;to draw or contain calculate
	NumPolys	dw	(?)	;number of polygons in object
	xrot		db	(?)	;256ths of a circle rotated on
	yrot		db	(?)	; the x, y, and z axis
	zrot		db	(?)
			db	(?)	;fills up space
	xtrans		dw	(?)	;where to draw object
	ytrans		dw	(?)
	ztrans		dw	(?)
	ToPolys		dd	(?)	;pointer to array of polygons

ENDS