;****************************************************************************
;DrawObject
;	takes pointer to object in edi, and in later revisions, off
;	the stack
;may eventually want to adjust light sourcing - shading structure
DrawObject proc


		mov [ObjPtr],edi		;later pop [ObjPtr]

		;set rotation
		mov eax,dword ptr fs:[(Object + edi).xrot]
		;mov bl,fs:[(Object + edi).yrot] ;make sure a dummy byte
		;mov dl,fs:[(Object + edi).zrot] ;is after zrot
		mov dword ptr [rotx],eax
		;mov [roty],bl
		;mov [rotz],dl

		;set where to transition to
		mov eax,dword ptr fs:[(Object + edi).xtrans]
		;mov bx,fs:[(Object + edi).ytrans]
		mov dx,fs:[(Object + edi).ztrans]
		mov dword ptr [tx],eax
		;mov [ty],bx

		call RotSet

		;get number of polygons
		xor ecx,ecx
		mov [tz],dx
		mov cx,fs:[(Object + edi).NumPolys] ;store # of polys

		;get pointer to polygons
		mov edi,fs:[(Object + edi).ToPolys]

TLoop:
		push ecx

		;Rotate Points for drawing
		mov eax,dword ptr fs:[(Polygon + edi).x1]
		;mov bx,fs:[(Polygon + edi).y1]
		mov dx,fs:[(Polygon + edi).z1]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov eax,dword ptr [rx]
		;mov bx,[ry]
		mov dx,[rz]
		mov dword ptr [pt1x],eax
		;mov [pt1y],bx
		mov [pt1z],dx

		mov eax,dword ptr fs:[(Polygon + edi).x2]
		;mov bx,fs:[(Polygon + edi).y2]
		mov dx,fs:[(Polygon + edi).z2]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov eax,dword ptr [rx]
		;mov bx,[ry]
		mov dx,[rz]
		mov dword ptr [pt2x],eax
		;mov [pt2y],bx
		mov [pt2z],dx

		mov eax,dword ptr fs:[(Polygon + edi).x3]
		;mov bx,fs:[(Polygon + edi).y3]
		mov dx,fs:[(Polygon + edi).z3]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov eax,dword ptr [rx]
		;mov bx,[ry]
		mov dx,[rz]
		mov dword ptr [pt3x],eax
		;mov [pt3y],bx
		mov [pt3z],dx

		mov eax,dword ptr fs:[(Polygon + edi).x4]
		;mov bx,fs:[(Polygon + edi).y4]
		mov dx,fs:[(Polygon + edi).z4]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov eax,dword ptr [rx]
		;mov bx,[ry]
		mov dx,[rz]
		mov dword ptr [pt4x],eax
		;mov [pt4y],bx
		mov [pt4z],dx

		;add on transitioning
		mov ax,[tx]
		mov bx,[ty]
		add [pt1x],ax
		mov dx,[tz]
		add [pt2x],ax
		add [pt1y],bx
		add [pt3x],ax
		add [pt4z],dx
		add [pt2y],bx
		add [pt2z],dx
		add [pt4x],ax
		add [pt3y],bx
		add [pt1z],dx
		add [pt4y],bx
		add [pt3z],dx

		movsx eax,[pt1x]	;load x
		movsx ebx,[pt1z]	;load z
		shl eax,zshift		;multiply eax by 256
		cdq
		add ebx,zadd		;add displacement to z
		idiv ebx		;divide edx:eax by ebx
		add ax,[LeftOfScreen] 	;move to where screen is
		mov [pt1x],ax ;save new x value
	      ;y1
		movsx eax,[pt1y]	;load y
		shl eax,zshift		;mul ax by 256
		cdq
		idiv ebx		;divide dx:ax by bx
		add ax,[TopOfScreen]	;move to where screen is
		mov [pt1y],ax
	     ;x2
		movsx eax,[pt2x]	;load x
		movsx ebx,[pt2z]	;load z
		shl eax,zshift		;multiply eax by 256
		cdq
		add ebx,zadd		;add displacement to z
		idiv ebx		;divide edx:eax by ebx
		add ax,[LeftOfScreen] 	;move to where screen is
		mov [pt2x],ax ;save new x value
	      ;y2
		movsx eax,[pt2y]	;load y
		shl eax,zshift		;mul ax by 256
		cdq
		idiv ebx		;divide dx:ax by bx
		add ax,[TopOfScreen]	;move to where screen is
		mov [pt2y],ax
	      ;x3
		movsx eax,[pt3x]	;load x
		movsx ebx,[pt3z]	;load z
		shl eax,zshift		;multiply eax by 256
		cdq
		add ebx,zadd		;add displacement to z
		idiv ebx		;divide edx:eax by ebx
		add ax,[LeftOfScreen] 	;move to where screen is
		mov [pt3x],ax ;save new x value
	      ;y3
		movsx eax,[pt3y]	;load y
		shl eax,zshift		;mul ax by 256
		cdq
		idiv ebx		;divide dx:ax by bx
		add ax,[TopOfScreen]	;move to where screen is
		mov [pt3y],ax
	      ;x4
		movsx eax,[pt4x]	;load x
		movsx ebx,[pt4z]	;load z
		shl eax,zshift		;multiply eax by 256
		cdq
		add ebx,zadd		;add displacement to z
		idiv ebx		;divide edx:eax by ebx
		add ax,[LeftOfScreen] 	;move to where screen is
		mov [pt4x],ax ;save new x value
	      ;y4
		movsx eax,[pt4y]	;load y
		shl eax,zshift		;mul ax by 256
		cdq
		idiv ebx		;divide dx:ax by bx
		add ax,[TopOfScreen]	;move to where screen is
		mov [pt4y],ax

		test fs:[(Polygon + edi).Flags],1
		jnz SkipHSR
	;see if the surface is hidden


		;accepts params in pt1x, pt1y, pt1z, pt2x, ...
		;returns in ecx
		mov ax,[pt2x] ;load
		mov bx,[pt1y] ;
		sub ax,[pt1x] ;x2 - x1
		sub bx,[pt3y] ;y1 - y3
		imul bx				;(x1-x2)(y1-y3) -> dx:ax
		mov cx,dx			;move dx:ax -> ecx
		mov bx,[pt2y] ;load
		shl ecx,16			;move dx:ax -> ecx
		mov cx,ax			;move dx:ax -> ecx
		mov ax,[pt1x] ;load
		sub bx,[pt1y] ;y2 - y1
		sub ax,[pt3x] ;x1 - x3
		imul bx				;(y2-y1)(x1-x3)
		shl edx,16			;prepare for ecx - edx
		mov dx,ax			;""
		sub ecx,edx		;(x1-x2)(y1-y3)-(y2-y1)(x1-x3)

		cmp ecx,0
		jg stm

	SkipHSR:

include shade.inc
comment ~
		call FindYNormal

		;light source shading	later make use of variables
		mov [Shade],0h
		cmp ecx,1836
		jg shendl
		cmp ecx,0
		mov [Shade],040h
		jg shendl
		cmp ecx,-1836
		mov [Shade],080h
		jg shendl
		mov [Shade],0c0h

shendl:
		;now do depth shading	later make use of variables
		;cmp [pt1z],-256
		;jl shend
		;or [Shade],0c0h
		cmp [pt1z],-128
		jl shend
		or [Shade],040h
		cmp [pt1z],0
		jl shend
		or [Shade],080h
		cmp [pt1z],128
		jl shend
		or [Shade],0c0h

shend:
~
		;load information for texture mapping
		mov edx,fs:[(Polygon + edi).ToMap]	;load Texture Map
		mov eax,dword ptr fs:[(Polygon + edi).numlpix] ;numl & h
		mov [MapOffset],edx

		mov cl,fs:[(Polygon + edi).NumPoints]
		mov [numverts],cl

		mov edx,fs:[(Polygon + edi).ToPoints]
		mov dword ptr [pixlen],eax
		mov [vertsat],edx

		mov ax,[pixheight]	;cut texturemaps short so skip
					;invisible at end
		shr ax,4
		sub [pixheight],ax

		call TextureMap

stm:

		pop ecx

		add edi,SizeofPolyS
		dec ecx
		jnz TLoop

		ret
ENDP



;****************************************************************************
;Texture Mapping Procedure 
;   calling: 	
;	[MapOffset] = pointer to array of pixels
;	spots on data are set (pt1x,pt1y,pt1z, ... pt3z , pixlen, pixheight)
;		zadd and zshift are constants for distortion
TextureMap proc
  ;convert points to 2 dimentional (store from x,y,z to x,y)
    ;sx = DIST * X / (DIST + Z)
    ;sy = DIST * Y / (DIST + Z)
      ;x1
push edi
;The actual texturemapping part
;----------------------------------------------------------------------------
  ;initialize height: find hdeltax and hdeltay
   ;yval & xval are +/-1 to add/sub from value, depending on where line goes
     ;Set up the height
	mov ax,[pt1x]		;load for later
	mov cx,[pt3x]		;copy pt3 onto height
	mov bx,[pt3y]		;

	sub ax,cx		;pt1x - pt3x

	cmp ax,0		;see if negative
	jge HNotNeg		;
	neg ax
 HNotNeg:
	mov dx,[pt1y]		;load pt1
	sub dx,bx		;pt1y - pt3y
	cmp dx,0		;see if negative
	jge HYNotNeg		;
	neg dx
 HYNotNeg:
  ;Initialize Variables
	cmp ax,dx		;compair deltax to deltay
	jbe hJump1

	;hdeltax >= hdeltay
	shl dx,1
	mov [hnumpixels],ax
	mov [hdet1],dx
	sub dx,ax
	mov [hd],dx
	sub dx,ax
	mov [hdet2],dx
	mov [hxval],1
	mov [hxval2],1
	mov [hyval],0
	mov [hyval2],1
	jmp hJumpE

 hJump1:
	;hdeltax < hdeltay
	shl ax,1
	mov [hnumpixels],dx
	mov [hdet1],ax
	sub ax,dx
	mov [hd],ax
	sub ax,dx
	mov [hdet2],ax
	mov [hxval],0
	mov [hxval2],1
	mov [hyval],1
	mov [hyval2],1
 hJumpE:

	;Make sure it moves the right direction
	mov ax,[pt1x]
	cmp ax,cx
	jbe hSkipSX
	neg [hxval]
	neg [hxval2]
 hSkipSX:
	mov ax,[pt1y]
	cmp ax,bx
	jbe hSkipSY
	neg [hyval]
	neg [hyval2]
 hSkipSY:


  ;initialize height: find hrdeltax and hrdeltay
   ;yval & xval are +/-1 to add/sub from value, depending on where line goes

     ;Set up the height
	mov ax,[pt2x]		;load for later
	mov cx,[pt4x]		;copy pt3 onto height
	mov bx,[pt4y]		;

	sub ax,cx		;pt1x - pt3x
	cmp ax,0		;see if negative
	jge HrNotNeg		;
	neg ax
 HrNotNeg:
	mov dx,[pt2y]		;load pt1
	sub dx,bx		;pt1y - pt3y
	cmp dx,0		;see if negative
	jge HrYNotNeg		;
	neg dx
 HrYNotNeg:
  ;Initialize Variables
	cmp ax,dx		;compair deltax to deltay
	jbe hrJump1

	;hrdeltax >= hrdeltay
	shl dx,1
	mov [hrnumpixels],ax
	mov [hrdet1],dx
	mov [hrxval],1
	sub dx,ax
	mov [hrxval2],1
	mov [hrd],dx
	sub dx,ax
	mov [hryval],0
	mov [hrdet2],dx
	mov [hryval2],1
	jmp hrJumpE

 hrJump1:
	;hrdeltax < hrdeltay
	shl ax,1
	mov [hrnumpixels],dx
	mov [hrxval],0
	mov [hrdet1],ax
	mov [hrxval2],1
	sub ax,dx
	mov [hryval],1
	mov [hrd],ax
	mov [hryval2],1
	sub ax,dx
	mov [hrdet2],ax
 hrJumpE:

	;Make sure it moves the right direction
	mov ax,[pt2x]
	cmp ax,cx
	jbe hrSkipSX
	neg [hrxval]
	neg [hrxval2]
 hrSkipSX:
	mov ax,[pt2y]
	cmp ax,bx
	jbe hrSkipSY
	neg [hryval]
	neg [hryval2]
 hrSkipSY:

 ;Done with height
 ;Do trapeziodial figuring (for perspective correctness)
	xor ebx,ebx
	xor eax,eax
	mov bx,[hnumpixels]
	mov ax,[hrnumpixels]
	xor edx,edx
	cmp ax,bx
	jae hrgreater

	;hnumpixels is greater
	shl eax,16
	div ebx
	mov [htrap],10000h
	mov [hrtrap],eax
	jmp nend

 hrgreater:
	;hrnumpixels is greater or are =
	mov [hnumpixels],ax
;	xchg eax,ebx
	push ebx
	mov ebx,eax
	pop eax
	shl eax,16
	div ebx
	mov [hrtrap],10000h
	mov [htrap],eax
 nend:

  ;Pre-Calculate number needed to be added to esi every time for length
	;need to better optimize these next few lines
	cmp bx,0
	je HrLDone
	xor edx,edx		;clear upper
	;xor ecx,ecx		;clear upper
	mov ax,[pixheight]	;load number of pixels
	shl eax,16		;move for precision
	div ebx			;divide # of pixels by the length
	mov [hDisplace],eax	;store result
	mov [hRunningTotal],0

	;stores 1 into x_numpixels if it is zero
	cmp [hnumpixels],0
	sete byte ptr [hnumpixels+1]
	cmp [hrnumpixels],0
	sete byte ptr [hrnumpixels+1]

  ;initialize z runners for point z buffering
    ;left side
	mov bx,[pt1z]		;load z depths of top and bottom
	mov ax,[pt3z]
	sub ax,bx
	xor ecx,ecx		;clear for later
	shl ebx,16		;shift left for precision
	mov cx,[hnumpixels]	;get number of height pixels
	mov [zhRunningTotal],ebx;save into zhRunningTotal

	shl eax,16
	mov edx,eax		;sign extend
	sar edx,31
	idiv ecx		;divide by # of pixels
	mov [zhDisplace],eax	;store amount for each step

    ;right side
	mov bx,[pt2z]		;load z depths of top and bottom
	mov ax,[pt4z]
	sub ax,bx

	xor ecx,ecx		;clear for later
	shl ebx,16		;shift left for precision
	mov cx,[hrnumpixels]	;get number of height pixels
	mov [zhrRunningTotal],ebx;save into zhRunningTotal

	shl eax,16
	mov edx,eax		;sign extend
	sar edx,31
	idiv ecx		;divide by # of pixels
	mov [zhrDisplace],eax	;store amount for each step

;initialize
	mov esi,[MapOffset]
	mov [htemp],0
	mov cx,[pt2x]		;copy pt2 onto height
	mov bx,[pt2y]		;
	mov [hrt],0
	mov [ht],0
	mov ax,[ScreenBuffer]
	mov [htlast],0
	mov es,ax
	mov [hrtlast],0
LineStart:
  ;initialize height: find deltax and deltay
   ;yval & xval are +/-1 to add/sub from value, depending on where line goes
	mov ax,[pt1x]		;load for later
	sub ax,cx		;pt1x - pt2x

	;find absolute value
	mov dx,ax
	sar dx,15
	xor ax,dx
	sub ax,dx

;	cmp ax,0		;see if negative
;	jge NotNeg		;
;	neg ax
; NotNeg:
	mov dx,[pt1y]		;load pt1
	sub dx,bx		;pt1y - pt2y
	cmp dx,0		;see if negative
	jge YNotNeg		;
	neg dx
 YNotNeg:
  ;Initialize Variables
	cmp ax,dx		;compair deltax to deltay
	jbe Jump1
	;deltax >= deltay
	shl dx,1
	mov [numpixels],ax
	mov [det1],dx
	mov [xval],1
	sub dx,ax
	mov [xval2],1
	mov [d],dx
	mov [yval],0
	sub dx,ax
	mov [yval2],1
	mov [det2],dx
	jmp JumpE

 Jump1:
	;deltax < deltay
	shl ax,1
	mov [numpixels],dx
	mov [det1],ax
	mov [xval],0
	sub ax,dx
	mov [xval2],1
	mov [d],ax
	mov [yval],1
	sub ax,dx
	mov [yval2],1
	mov [det2],ax
 JumpE:

	;Make sure it moves the right direction
	mov ax,[pt1x]
	cmp ax,cx
	jbe SkipSX
	neg [xval]
	neg [xval2]
 SkipSX:
	mov ax,[pt1y]
	cmp ax,bx
	jbe SkipSY
	neg [yval]
	neg [yval2]
 SkipSY:

  ;Pre-Calculate number needed to be added to esi every time for length
	;need to better optimize these next few lines
	cmp [numpixels],0
	je LDone
	xor edx,edx		;clear upper
	xor ecx,ecx		;clear upper
	mov ax,[pixlen]		;load number of pixels
	mov cx,[numpixels]	;load real length
	shl eax,16		;move for precision
	div ecx			;divide # of pixels by the length
	mov [RunningTotal],0
	mov [Displace],eax	;store result

	;store 1 into numpixels if it is 0
	;cmp [numpixels],0
	;sete byte ptr [numpixels+1]

  ;initialize z runners for point z buffering
	mov ebx,[zhRunningTotal];load z depths of top and bottom
	mov eax,[zhrRunningTotal]
	sub eax,ebx

	xor ecx,ecx		;clear for later
	;shl ebx,16		;shift left for precision
	mov cx,[numpixels]	;get number of height pixels
	mov [zRunningTotal],ebx;save into zhRunningTotal

	mov edx,eax		;sign extend
	sar edx,31
	idiv ecx		;divide by # of pixels
	mov [zDisplace],eax	;store amount for each step

	;set opposite direction to fill
	mov ax,[pt2x]
	cmp [pt1x],ax
	jge ggg

		mov ax,[pt2y]
		cmp [pt1y],ax
		jge ggg2
		mov [direction],640*2
		jmp gggend

	ggg2:
		mov [direction],1*2
		jmp gggend

ggg:

		mov ax,[pt2y]
		cmp [pt1y],ax
		jge ggg3
		mov [direction],-1*2
		jmp gggend

	ggg3:
		mov [direction],-640*2
gggend:

   ;Load init. stuff
	mov cx,[pt1x]
	mov bx,[pt1y]
	mov [temp],0
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Line:
	mov [cxtemp],cx		;store for later
	cmp bx,479+480		;see if off screen
	jge SkipPixel		;
	cmp bx,480
	jle SkipPixel
	cmp cx,640+639		;see if off screen
	jge SkipPixel		;
	cmp cx,640
	jle SkipPixel

	xor eax,eax
	mov ax,bx

	and ecx,0000ffffh	;clear upper
	sub eax,480
	imul eax,640		;multiply eax by ebx (640*x)
				;stores in edx:eax, but only uses eax
	 ;cleared upper edx when shr edx,16  14 lines up
	add eax,ecx		;add offset of x to address
	sub eax,640*2
	shl eax,1		;multiply by 2
	mov [DrawTo],eax	;save for later
	add eax,[zbuffer]	;get adress
	mov dx,gs:[eax]		;get point
			;use gs because fs is used in text drawer

	cmp [AllowDepth],1	;see if should skip depth checking
	mov ecx,[zRunningTotal]
	jne SkipDepthCheck
	dec dx		;give it a better chance to draw it
	shr ecx,16
	cmp cx,dx	;compare z to draw with the one already there
	jg SkipPixel
 SkipDepthCheck:

	;save addresses and values for later (when plotting)
	mov edx,[RunningTotal]	;load RunningTotal
	mov [ctemp],ecx		;store for later
	shr edx,16		;divide edx by 65536 (mul'ed it earlier)
	mov [atemp],eax		;store for later
	mov cx,fs:[esi+2*edx]  ;load color
	cmp cx,Clear		;see if color is clear
	je SkipPixel		;skip if clear
;	cmp cx,7		;see if color is anti-aliasing
;	je AAPixel		;jump to anti-aliasing

	;or cx,[Shade]		;add shade displacement
	;add shade
	push bx		;save
	push di
	mov ax,cx	;get bits & shift all to right
	mov bx,cx
	mov dx,cx
	and ax,1111100000000000b
	and bx,11111100000b
	and dx,11111b
	shr ax,11
	mov cx,[Shade]	;get
	shr bx,5

	mov di,cx	;get red part of shade
	and di,1111100000000000b
	shr di,11
	add dx,di	;add shade to each

	mov di,cx	;get green part of shade
	and di,11111100000b
	shr di,5
	add bx,di

	mov di,cx	;get blue part of shade
	and di,11111b
	add ax,di

	cmp ax,32	;see if any go over the limit -if so, set to max
	jb skipaxa
	mov ax,31
  skipaxa:
	cmp bx,64
	jb skipbxa
	mov bx,63
  skipbxa:
	cmp dx,32
	jb skipdxa
	mov dx,31
  skipdxa:

	shl ax,11
	shl bx,5

	or ax,bx	;put together
	or ax,dx
	pop di
	pop bx		;retrieve
	mov cx,ax

	mov eax,[DrawTo]

	mov es:[eax],cx
	movsx edx,[direction]
	sub eax,edx
	mov es:[eax],cx  ;draw color

	;saved from earlier movsx edx,[direction]
	;restore depth maps and draw to depth field
	mov eax,[atemp]
	mov ecx,[ctemp]
	mov word ptr gs:[eax],cx
	sub eax,edx
	cmp word ptr gs:[eax],cx
	jl SkipPixel

	mov word ptr gs:[eax],cx

 SkipPixel:
	mov ecx,[zRunningTotal]	;load for zbuffer
	mov edx,[RunningTotal]	;load (if loaded before, it is altered)
	mov ax,[temp]
	add ecx,[zDisplace]	;add displacement
	add edx,[Displace]	;add new displacement
	mov [zRunningTotal],ecx	;store new zbuffer
	inc ax
	mov [RunningTotal],edx	;save RunningTotal
	cmp [numpixels],ax	;see if done
	mov dx,[d]		;
	mov cx,[cxtemp]		;reload x
	jb LDone
	mov [temp],ax
	cmp dx,0
	jge Other
	;d < 0
	add dx,[det1]
	add cx,[xval]
	mov [d],dx
	add bx,[yval]
	jmp Line

 Other:
	;d >= 0
	add dx,[det2]
	add cx,[xval2]
	mov [d],dx
	add bx,[yval2]
	jmp Line
LDone:
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

HLine:
	mov ebx,[zhrRunningTotal];load right zbuffering
	mov ecx,[zhRunningTotal];load zbuffering
	add ebx,[zhrDisplace]	;add z buffer
	mov eax,[hRunningTotal]	;load (if loaded before, it is altered)
	mov [zhrRunningTotal],ebx
	mov dx,[htemp]
	add ecx,[zhDisplace]	;add z buffer
	add eax,[hDisplace]	;add new displacement
	mov [zhRunningTotal],ecx;store z buffer
	inc dx
	xor ebx,ebx
	cmp [hnumpixels],dx	;see if done
	jb TMDone

	mov [hRunningTotal],eax	;save RunningTotal
	mov bx,[pixlen]
	shr eax,16
	mov [htemp],dx
	imul eax,ebx
	shl eax,1		;2bytes/pixel [modified]
	add eax,[MapOffset]
	mov esi,eax

	mov bx,[pt1y]	;reload variables
	mov eax,[ht]
	mov dx,[hd]
	shr eax,16
	mov cx,[pt1x]
	cmp ax,[htlast]
	jb HLDone
	inc ax

	cmp dx,0
	mov [htlast],ax
	jge hOther

	;d < 0
	add dx,[hdet1]
	add cx,[hxval]
	mov [hd],dx
	add bx,[hyval]
	mov [pt1x],cx
	mov [pt1y],bx
	jmp HLDone

 hOther:
	;d >= 0
	add dx,[hdet2]
	add cx,[hxval2]
	mov [hd],dx
	add bx,[hyval2]
	mov [pt1x],cx
	mov [pt1y],bx
HLDone:

	mov eax,[ht]
	mov dx,[hrd]
	add eax,[htrap]
	mov cx,[pt2x]
	mov [ht],eax
	mov bx,[pt2y]

 ;'Right' Side
	mov eax,[hrt]
	shr eax,16
	cmp ax,[hrtlast]
	jb HrLDone
	inc ax

	cmp dx,0
	mov [hrtlast],ax
	jge hrOther

	;d < 0
	add dx,[hrdet1]
	add cx,[hrxval]
	mov [hrd],dx
	add bx,[hryval]
	mov [pt2x],cx
	mov [pt2y],bx
	jmp HrLDone

 hrOther:
	;d >= 0
	add dx,[hrdet2]
	add cx,[hrxval2]
	mov [hrd],dx
	add bx,[hryval2]
	mov [pt2x],cx
	mov [pt2y],bx
HrLDone:

	mov eax,[hrt]
	add eax,[hrtrap]
	mov [hrt],eax
	jmp LineStart

TMDone:
;Anti-Aliasing is now done by pixels;Now anti-alias the boarder

;	cmp [skipaa],1
;	je NoAAThisTime
;	include aa.inc
;	NoAAThisTime:

	pop edi
	ret

comment ~
AAPixel:	;jump here if anti-aliasing

push esi
mov esi,[DrawTo]
;=========================================================================
	push bx
	xor ax,ax			;
	xor bx,bx			;
	xor cx,cx			;
	xor edx,edx			;

	mov al,es:[esi-1]		;grab points around point
	mov bl,es:[esi-640]
	mov cl,es:[esi+1]
	mov dl,es:[esi+640]
	add ax,bx			;add
	add ax,dx			;add for colors
	mov dl,es:[esi]			;load point
	add ax,cx			;add
	shl edx,2			;multiply by 4
	add ax,dx			;
	mov bl,es:[esi]			;load shade of point
	shr ax,3			;take average
	and bl,00000111b		;take shade portion
	and al,11111000b		;take color portion only
	or al,bl;[Shade]	;use shade of Texture Map

	mov byte ptr es:[esi],al	;store new color & shade
	pop bx
	pop esi
	jmp SkipPixel
~
ENDP


;****************************************************************************
;Line Drawer
;   calling: 	
;	color is the color
;	spots on data are set (pt1x,pt1y,pt1z, ... pt2z)
;		zadd and zshift are constants for distortion
DrawLine proc
  ;convert points to 2 dimentional (store from x,y,z to x,y)
    ;sx = DIST * X / (DIST + Z)
    ;sy = DIST * Y / (DIST + Z)
      ;x1
	movsx eax,[pt1x]	;load x
	movsx ebx,[pt1z]	;load z
	shl eax,zshift		;multiply eax by 256
	cdq
	add ebx,zadd		;add displacement to z
	idiv ebx		;divide edx:eax by ebx
	add ax,[LeftOfScreen] 	;move to where screen is
	mov [pt1x],ax		;save new x value
      ;y1
	movsx eax,[pt1y]	;load y
	shl eax,zshift		;mul ax by 256
	cdq
	idiv ebx		;divide dx:ax by bx
	add ax,[TopOfScreen]	;move to where screen is
	mov [pt1y],ax
     ;x2
	movsx eax,[pt2x]	;load x
	movsx ebx,[pt2z]	;load z
	shl eax,zshift		;multiply eax by 256
	cdq
	add ebx,zadd		;add displacement to z
	idiv ebx		;divide edx:eax by ebx
	add ax,[LeftOfScreen] 	;move to where screen is
	mov [pt2x],ax		;save new x value
      ;y2
	movsx eax,[pt2y]	;load y
	shl eax,zshift		;mul ax by 256
	cdq
	idiv ebx		;divide dx:ax by bx
	add ax,[TopOfScreen]	;move to where screen is
	mov [pt2y],ax

;initialize
	mov cx,[pt2x]		;copy pt2 onto height
	mov bx,[pt2y]		;
	mov ax,[ScreenBuffer]
	mov es,ax
LineStartL:
  ;initialize height: find deltax and deltay
   ;yval & xval are +/-1 to add/sub from value, depending on where line goes
	mov ax,[pt1x]		;load for later
	sub ax,cx		;pt1x - pt2x
	cmp ax,0		;see if negative
	jge NotNegL		;
	neg ax
 NotNegL:
	mov dx,[pt1y]		;load pt1
	sub dx,bx		;pt1y - pt2y
	cmp dx,0		;see if negative
	jge YNotNegL		;
	neg dx
 YNotNegL:
  ;Initialize Variables
	cmp ax,dx		;compair deltax to deltay
	jbe Jump1L

	;deltax >= deltay
	shl dx,1
	mov [numpixels],ax
	mov [det1],dx
	mov [xval],1
	sub dx,ax
	mov [xval2],1
	mov [d],dx
	mov [yval],0
	sub dx,ax
	mov [yval2],1
	mov [det2],dx
	jmp JumpEL

 Jump1L:
	;deltax < deltay
	shl ax,1
	mov [numpixels],dx
	mov [det1],ax
	mov [xval],0
	sub ax,dx
	mov [xval2],1
	mov [d],ax
	mov [yval],1
	sub ax,dx
	mov [yval2],1
	mov [det2],ax
 JumpEL:

	;Make sure it moves the right direction
	mov ax,[pt1x]
	cmp ax,cx
	jbe SkipSXL
	neg [xval]
	neg [xval2]
 SkipSXL:
	mov ax,[pt1y]
	cmp ax,bx
	jbe SkipSYL
	neg [yval]
	neg [yval2]
 SkipSYL:

	mov cx,[pt1x]
	mov bx,[pt1y]
	mov [temp],0
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
LineL:
	mov [cxtemp],cx		;store for later
	cmp bx,479+480		;see if off screen
	jge SkipPixelL		;
	cmp bx,480
	jle SkipPixelL
	cmp cx,640+639		;see if off screen
	jge SkipPixelL		;
	cmp cx,640
	jle SkipPixelL

	xor eax,eax		;clear eax for mul later
	mov cx,[color]		;load color
	mov ax,bx		;load bx into ax for mul
	;mov edx,640		;for multiplying
	sub eax,480
	imul eax,640		;multiply eax by ebx (640*x)
				;stores in edx:eax, but only uses eax
	xor edx,edx		;clear edx (upper)
	mov dx,[cxtemp]		;restore x (from cx)
	add eax,edx		;add offset of x to address
	sub eax,640*2

	cmp eax,4b000h		;see if off screen
	jae SkipPixelL
	shl eax,1
	mov es:[eax],cx  ;draw color
 SkipPixelL:
	mov ax,[temp]
	mov cx,[cxtemp]		;reload x
	inc ax
	mov dx,[d]		;
	cmp [numpixels],ax	;see if done
	jb LDoneL
	mov [temp],ax
	cmp dx,0
	jge OtherL
	;d < 0
	add dx,[det1]
	add cx,[xval]
	mov [d],dx
	add bx,[yval]
	jmp LineL

 OtherL:
	;d >= 0
	add dx,[det2]
	add cx,[xval2]
	mov [d],dx
	add bx,[yval2]
	jmp LineL
LDoneL:

ret
color dw	(?)
ENDP



;****************************************************************************
;Line Drawer for Polygon TextureMaps
;   calling: 	
;	color is the color
;	takes map offset in edi (assumes fs)
;		takes size in MapWidth, MapHeight
;	only need points in x&y: z is assumed 0 for memory allocation
;	spots on data are set (pt1x,pt1y ... pt2y , pixlen, pixheight)
TMLine proc
;initialize
	mov cx,[pt2x]		;copy pt2 onto height
	mov bx,[pt2y]		;

MLineStartL:
  ;initialize height: find deltax and deltay
   ;yval & xval are +/-1 to add/sub from value, depending on where line goes
	mov ax,[pt1x]		;load for later
	sub ax,cx		;pt1x - pt2x
	cmp ax,0		;see if negative
	jge MNotNegL		;
	neg ax
 MNotNegL:
	mov dx,[pt1y]		;load pt1
	sub dx,bx		;pt1y - pt2y
	cmp dx,0		;see if negative
	jge MYNotNegL		;
	neg dx
 MYNotNegL:
  ;Initialize Variables
	cmp ax,dx		;compair deltax to deltay
	jbe MJump1L

	;deltax >= deltay
	shl dx,1
	mov [numpixels],ax
	mov [det1],dx
	mov [xval],1
	sub dx,ax
	mov [xval2],1
	mov [d],dx
	mov [yval],0
	sub dx,ax
	mov [yval2],1
	mov [det2],dx
	jmp MJumpEL

 MJump1L:
	;deltax < deltay
	shl ax,1
	mov [numpixels],dx
	mov [det1],ax
	mov [xval],0
	sub ax,dx
	mov [xval2],1
	mov [d],ax
	mov [yval],1
	sub ax,dx
	mov [yval2],1
	mov [det2],ax
 MJumpEL:

	;Make sure it moves the right direction
	mov ax,[pt1x]
	cmp ax,cx
	jbe MSkipSXL
	neg [xval]
	neg [xval2]
 MSkipSXL:
	mov ax,[pt1y]
	cmp ax,bx
	jbe MSkipSYL
	neg [yval]
	neg [yval2]
 MSkipSYL:

	mov cx,[pt1x]
	mov bx,[pt1y]
	mov [temp],0
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
MLineL:
	mov [cxtemp],cx		;store for later
	mov cx,[color]		;load color
	xor eax,eax		;clear eax for mul later
	xor edx,edx
	xor esi,esi
	mov ax,bx		;load bx into ax for mul
	mov dx,[MapWidth]	;for multiplying
	mov si,[MapHeight]
	mul edx			;multiply eax by ebx (640*x)
				;stores in edx:eax, but only uses eax
	xor edx,edx		;clear edx (upper)
	mov dx,[cxtemp]		;restore x (from cx)
	add eax,edx		;add offset of x to address
	shl eax,1
	add eax,edi
 ;on next line, later (once all data is allocated) mov fs:[eax],cl
	mov fs:[eax],cx  ;draw color
 MSkipPixelL:
	mov ax,[temp]
	inc ax
	mov dx,[d]		;
	cmp [numpixels],ax	;see if done
	mov cx,[cxtemp]		;reload x
	jb MLDoneL
	mov [temp],ax
	cmp dx,0
	jge MOtherL
	;d < 0
	add dx,[det1]
	add cx,[xval]
	mov [d],dx
	add bx,[yval]
	jmp MLineL

 MOtherL:
	;d >= 0
	add dx,[det2]
	add cx,[xval2]
	mov [d],dx
	add bx,[yval2]
	jmp MLineL
MLDoneL:

ret
MapWidth	dw	(?)
MapHeight	dw	(?)
ENDP

;****************************************************************************
Plot proc
	;takes point in pt1x,pt1y,pt1z, color in ax
	mov [color],ax
	mov bx,[ScreenBuffer]
	mov es,bx
      ;x1
	movsx eax,[pt1x]	;load x
	movsx ebx,[pt1z]	;load z
	shl eax,zshift		;multiply eax by 256
	cdq
	add ebx,zadd		;add displacement to z
	idiv ebx		;divide edx:eax by ebx
	xor ecx,ecx
	add ax,[LeftOfScreen] 	;move to where screen is
	mov cx,ax		;save new x value
      ;y1
	movsx eax,[pt1y]	;load y
	shl eax,zshift		;mul ax by 256
	cdq
	idiv ebx		;divide dx:ax by bx
	add ax,[TopOfScreen]	;move to where screen is

	cmp cx,640+639		;see if off screen
	jge Noplot		;
	cmp cx,640
	jle Noplot
	cmp ax,479+480		;see if off screen
	jge Noplot		;
	cmp ax,480
	jle Noplot

	sub ax,480
	mov bx,640
	mul bx			;mul y by 640
	shl edx,16		;convert dx:ax to edx
	mov dx,ax		;
	add edx,ecx		;640 * y + x
	sub edx,640*2
	cmp edx,96000h		;see if off screen
	jae Noplot
	mov ax,[color]
	shl edx,1
	mov es:[edx],ax
Noplot:
	ret
ENDP