include nummap.inc

;****************************************************************************
;Shows a decimal using 3d graphics
;number to be shown is in ax (if need longer number, put first half then 2nd)
;x is in cx, y is in bx, height is in upper edx, length is in lower edx
;default size is 3x5
ShowDec proc

	add cx,640
	add bx,480
	mov [xtemp],cx
	mov [ytemp],bx
	mov [numsize],edx
	mov [number],ax

	cmp ax,0
	jge NNegS
	neg ax
	mov [number],ax
	;display negative sign

	mov [pt1x],cx
	mov [pt1y],bx

	add cx,dx
	mov [pt2y],bx
	mov [pt2x],cx

	mov ax,[xtemp]	;load x
	shr edx,16
	mov [pt3x],ax
	add bx,dx
	mov [pt3y],bx

	mov ax,[xtemp]	;load x
	mov edx,[numsize]
	mov [pt4y],bx
	add ax,dx
	mov [pt4x],ax

	mov eax,offset NegSign
	mov bx,[foreground]	;load color
	;mov [skipaa],1
	mov [MapOffset],eax
	mov [Shade],bx
	mov [pixlen],5
	mov [pixheight],5

	push fs		;make it look at data
	push ds
	pop fs

	mov [AllowDepth],0
	call TextureMap
	mov [AllowDepth],1
	pop fs
	;mov [skipaa],0

	mov edx,[numsize]
	add [xtemp],dx
NNegS:
	mov ecx,1
	cmp ax,9
	jbe LenDone
	inc ecx
	cmp ax,99
	jbe LenDone
	inc ecx
	cmp ax,999
	jbe LenDone
	inc ecx
	cmp ax,9999
	jbe LenDone
	inc ecx
LenDone:

	;start doing
	mov cx,10000
	mov [zeros],0
NumberLoop:
	mov ax,[number]
	xor edx,edx
	div cx
	;now dx contains what's left over
	mov [number],dx

	;unless it's the last zero, don't draw
	cmp ecx,1
	je SkipEcx
	cmp ax,0
	sete [tester]
	cmp [zeros],0
	sete bl
	and bl,[tester]
	cmp bl,1
	jne SkipEcx

SpecialCase:
	mov ax,cx
	xor edx,edx
	mov bx,10
	div bx
	mov cx,ax

	jmp NumberLoop
SkipEcx:
	mov [zeros],1
	mov dx,30
	;multiply the number by 30 (the size of a number char)
	mul dx

	shl edx,16
	mov dx,ax
	shl edx,1
	mov ebx,offset [ZeroMap]
	add ebx,edx
	mov [MapOffset],ebx

	mov ax,[foreground]	;load color
	;mov [skipaa],1
	mov [pixlen],5
	mov [Shade],ax		;store shade
	mov [pixheight],5
push ecx

	mov cx,[xtemp]
	mov bx,[ytemp]
	mov [pt1x],cx
	mov [pt1y],bx

	mov edx,[numsize]
	add cx,dx
	mov [pt2y],bx
	mov [pt2x],cx

	mov ax,[xtemp]	;load x
	shr edx,16
	mov [pt3x],ax
	add bx,dx
	mov [pt3y],bx

	mov ax,[xtemp]	;load x
	mov edx,[numsize]
	mov [pt4y],bx
	add ax,dx
	mov [pt4x],ax

	push fs		;make it look at data
	push ds
	pop fs
	mov [AllowDepth],0
	call TextureMap
	mov [AllowDepth],1
	pop fs
	;mov [skipaa],0
	pop ecx
	mov edx,[numsize]
	add [xtemp],dx

	cmp ecx,1
	je Returnme

	mov ax,cx
	xor edx,edx
	mov bx,10
	div bx
	mov cx,ax
	jmp NumberLoop

Returnme:
	ret

zeros	dw	(?)
xtemp	dw	(?)
ytemp	dw	(?)
numsize	dd	(?)
number	dw	(?)
tester	db	(?)

ENDP

;****************************************************************************
;Writes string to screen
;x is in cx, y is in bx, height is in upper edx, length is in lower edx
;ds:esi is pointer to zero terminated string
Write proc

	sub cx,dx
	add bx,480	;tack on extra screen
	add cx,640
	mov [numsize],edx
	dec cx
	mov [ytemp],bx
	mov [xtemp],cx

 SWriteLoop:
	add [xtemp],dx	;move along string
	inc [xtemp]
	xor eax,eax
	mov al,ds:[esi]
	inc esi
	cmp al,0
	je EndOfSWrite

	;see if upper case
	cmp al,90
	ja NotCaps
	cmp al,65
	jb NotCaps
	add al,32	;convert to lower case
  NotCaps:

	cmp al,122	;see if character is letter
	ja OddChar
	cmp al,97
	jae GoWrite

	cmp al,20h	;space
	je SWriteLoop

	;test for some other character
  OddChar:		;misc. characters

	push esi

	cmp al,'0'	;see if number
	jb NotWNum
	cmp al,'9'
	ja NotWNum

	xor ebx,ebx
	sub al,'0'

	mov bx,60
	mul bx

	mov ebx,offset ZeroMap
	shl edx,16
	add ebx,eax
	add ebx,edx
	mov [MapOffset],ebx
	jmp ContWrite

    NotWNum:

	cmp al,':'	; ':'
	jne NotWrC
	mov eax,offset Colon
	mov [MapOffset],eax
	jmp ContWrite
    NotWrC:

	cmp al,'\'	; '\'
	jne NotBkSlsh
	mov eax,offset BkSlsh
	mov [MapOffset],eax
	jmp ContWrite
    NotBkSlsh:

	cmp al,'.'	; '.'
	jne NotPeriod
	mov eax,offset Period
	mov [MapOffset],eax
	jmp ContWrite
    NotPeriod:

	pop esi		;undo pushing it
	jmp SWriteLoop	;I give up what character it is
  GoWrite:	;write alphabetic character
	push esi
	xor ebx,ebx
	sub al,'a'

	mov bx,60
	mul bx

	mov ebx,offset AMap
	shl edx,16
	add ebx,eax
	add ebx,edx
	mov [MapOffset],ebx

  ContWrite:
	mov ax,[foreground]	;load color
	;mov [skipaa],1
	mov [pixlen],5
	mov [Shade],ax		;store color
	mov [pixheight],5

	mov cx,[xtemp]
	mov bx,[ytemp]
	mov [pt1x],cx
	mov [pt1y],bx

	mov edx,[numsize]
	add cx,dx
	mov [pt2y],bx
	mov [pt2x],cx

	mov ax,[xtemp]	;load x
	shr edx,16
	mov [pt3x],ax
	add bx,dx
	mov [pt3y],bx

	mov ax,[xtemp]	;load x
	mov edx,[numsize]
	mov [pt4y],bx
	add ax,dx
	mov [pt4x],ax

	push fs		;make it look at data
	push ds
	pop fs
	mov [AllowDepth],0
	call TextureMap
	mov [AllowDepth],1
	pop fs
	;mov [skipaa],0
	mov edx,[numsize]
	pop esi
	jmp SWriteLoop

EndOfSWrite:
	mov bx,[ytemp]
	mov cx,[xtemp]
	sub bx,480
	sub cx,640
	ret
ENDP


;****************************************************************************
;Draws pointer to screen
;x is in cx, y is in bx, height is in upper edx, length is in lower edx
Point proc

	add bx,480
	add cx,640

	mov [numsize],edx
	dec cx
	mov [ytemp],bx
	mov [xtemp],cx

	mov ebx,offset PointMap

	mov ax,[foreground]
	;mov [skipaa],1
	mov [MapOffset],ebx
	mov [Shade],ax
	mov [pixlen],5
	mov [pixheight],5

	mov cx,[xtemp]
	mov bx,[ytemp]
	mov [pt1x],cx
	mov [pt1y],bx

	mov edx,[numsize]
	add cx,dx
	mov [pt2y],bx
	mov [pt2x],cx

	mov ax,[xtemp]	;load x
	shr edx,16
	mov [pt3x],ax
	add bx,dx
	mov [pt3y],bx

	mov ax,[xtemp]	;load x
	mov edx,[numsize]
	mov [pt4y],bx
	add ax,dx
	mov [pt4x],ax

	push fs		;make it look at data
	push ds
	pop fs
	mov [AllowDepth],0
	call TextureMap
	mov [AllowDepth],1
	pop fs
	;mov [skipaa],0

	ret
ENDP