;Keyboard handler - for different modes of editor
		mov dx,[kv]	;load

		;default keys - present in every state
		cmp ax,2d00h	;see if x (if is, exit)
		je EndLoop

		;fast & slow movement
		cmp ax,2166h
		jne NotF
		add [kv],1
		jmp Bigloop
	NotF:
		cmp ax,1f73h
		jne NotS
		sub [kv],1
		jmp Bigloop
	NotS:

		cmp ax,2064h	;toggle degrees display
		jne NotDKey
		xor [DispDegrees],1
		jmp Bigloop
	NotDKey:

		cmp ax,2f76h	;v key toggles viewing state only
		jne NotVKey
		mov ax,[DrawStat]
		xor ax,1
		mov [DrawStat],ax
		mov [DrawAxis],ax
		jmp Bigloop
	NotVKey:


		cmp ax,1372h	;r key resets positions
		jne NotRKey
		mov word ptr fs:[(Object + edi).xrot],0
		;mov fs:[(Object + edi).yrot],0
		mov fs:[(Object + edi).zrot],0
		mov dword ptr fs:[(Object + edi).xtrans],0
		;mov fs:[(Object + edi).ytrans],0
		mov fs:[(Object + edi).ztrans],0

		;reset box position
		mov word ptr [box],-30
		mov word ptr [box+2],-30
		mov word ptr [box+4],0
		mov word ptr [box+6],30
		mov word ptr [box+8],-30
		mov word ptr [box+10],0
		mov word ptr [box+12],30
		mov word ptr [box+14],30
		mov word ptr [box+16],0
		mov word ptr [box+18],-30
		mov word ptr [box+20],30
		mov word ptr [box+22],0
		mov word ptr [box+24],-30
		mov word ptr [box+26],-30
		mov word ptr [box+28],0
		mov word ptr [nextbox],-30
		mov word ptr [nextbox+2],-30
		mov word ptr [nextbox+4],0
		mov word ptr [nextbox+6],30
		mov word ptr [nextbox+8],-30
		mov word ptr [nextbox+10],0
		mov word ptr [nextbox+12],30
		mov word ptr [nextbox+14],30
		mov word ptr [nextbox+16],0
		mov word ptr [nextbox+18],-30
		mov word ptr [nextbox+20],30
		mov word ptr [nextbox+22],0
		mov word ptr [nextbox+24],-30
		mov word ptr [nextbox+26],-30
		mov word ptr [nextbox+28],0
		mov dword ptr [bpointerx],0
		;mov [bpointery],0
		mov [bpointerz],0
		mov word ptr [brotx],0
		;mov [broty],0
		mov [brotz],0
		mov dword ptr [bfptrx],0
		;mov [bfptry],0
		mov [bfptrz],0
		jmp Bigloop
	NotRKey:

		cmp ax,3062h	;adjust background color
		jne NotB
		mov eax,[background]
		add ax,dx
		push ax
		shl eax,16
		pop ax
		mov [background],eax
		jmp Bigloop
	NotB:
		cmp ax,316eh	;adjust forground color (next to b)
		jne NotN
		add [foreground],dx
		jmp Bigloop
	NotN:

		cmp ax,3b00h	;F1 -display about
		jne NotF1
	PrognCInfo:
		mov cx,100
		mov bx,220
		mov edx,0a000ah
		mov esi,offset prgname
		call Write

		mov cx,50
		mov bx,240
		mov edx,0a000ah
		mov esi,offset myname
		call Write
		FlushSBuffer
		xor ax,ax
		int 16h
		jmp Bigloop
	NotF1:

		cmp ax,1e61h	;a
		jne NotAKey
		xor [DrawAxis],1
		jmp Bigloop
	NotAKey:

		;see if file saving/opening/new are taking place
		include kbfile.inc


	;see what state the editor is in
		mov [mouseshade],0	;clear if set by pointing
		cmp [state],1
		je pstate
		cmp [state],2
		je ppstate
		cmp [state],3
		je pbstate
		cmp [state],4
		je tmstate
		cmp [state],5
		je Editstate
		cmp [state],6
		je Lightstate

		mov [zzindex],0	;used for flipping through points

	;test for keys
	;see if togling state
		cmp ax,1c0dh
		jne asdfjkl
		add [state],1
		mov [mpointerx],0
		mov [mpointery],0
		mov [plotyet],0
		jmp Bigloop
	asdfjkl:
	;see if edititing texture map
		cmp ax,0f09h	;tab
		jne tasdfjkl
		mov [state],4
		jmp Bigloop
	tasdfjkl:

	;see if adjusting light source
		cmp ax,266ch
		jne notadjlight
		mov [state],6
		jmp Bigloop
	notadjlight:

		cmp ax,4b00h
		jne NotL
		sub fs:[(Object+edi).xtrans],dx
		jmp Bigloop
	NotL:
		cmp ax,4d00h
		jne NotR
		add fs:[(Object+edi).xtrans],dx
		jmp Bigloop
	NotR:
		cmp ax,4800h
		jne NotU
		sub fs:[(Object+edi).ytrans],dx
		jmp Bigloop
	NotU:
		cmp ax,5000h
		jne NotD
		add fs:[(Object+edi).ytrans],dx
		jmp Bigloop
	NotD:
		cmp ax,4700h
		jne NotH
		add fs:[(Object+edi).ztrans],dx
		jmp Bigloop
	NotH:
		cmp ax,4f00h
		jne NotE
		sub fs:[(Object+edi).ztrans],dx
		jmp Bigloop
	NotE:
		cmp ax,4b34h
		jne Not4
		add fs:[(Object+edi).yrot],dl
		jmp Bigloop
	Not4:
		cmp ax,4d36h
		jne Not6
		sub fs:[(Object+edi).yrot],dl
		jmp Bigloop
	Not6:
		cmp ax,4838h
		jne Not8
		sub fs:[(Object+edi).xrot],dl
		jmp Bigloop
	Not8:
		cmp ax,5032h
		jne Not2
		add fs:[(Object+edi).xrot],dl
		jmp Bigloop
	Not2:
		cmp ax,4737h
		jne Not7
		sub fs:[(Object+edi).zrot],dl
		jmp Bigloop
	Not7:
		cmp ax,4939h
		jne Not9
		add fs:[(Object+edi).zrot],dl
		jmp Bigloop
	Not9:

	jmp Bigloop
;****************************************************************************
;pstate - plotting state 1 - move drawing box
pstate:

	;see if togling state
		cmp ax,011bh
		jne NotEscP
		dec [state]
		jmp Bigloop
	NotEscP:
	;see if togling state
		cmp ax,0f09h		;see if going to normal poly
		jne NotTabP
		inc [state]
		jmp Bigloop
	NotTabP:
		cmp ax,1c0dh		;see if going to 4 pt poly
		jne NotEntP
		add [state],2		;it is state 4
		mov  [fpointon],0	;start with the first point
		jmp Bigloop
	NotEntP:

		cmp ax,4b00h
		jne NotLP
		sub [bpointerx],dx
		jmp Bigloop
	NotLP:
		cmp ax,4d00h
		jne NotRP
		add [bpointerx],dx
		jmp Bigloop
	NotRP:
		cmp ax,4800h
		jne NotUP
		sub [bpointery],dx
		jmp Bigloop
	NotUP:
		cmp ax,5000h
		jne NotDP
		add [bpointery],dx
		jmp Bigloop
	NotDP:
		cmp ax,4700h
		jne NotHP
		add [bpointerz],dx
		jmp Bigloop
	NotHP:
		cmp ax,4f00h
		jne NotEP
		sub [bpointerz],dx
		jmp Bigloop
	NotEP:
		cmp ax,4b34h	;rotating new box
		jne Not4P
		add [broty],dl
		jmp Bigloop
	Not4P:
		cmp ax,4d36h
		jne Not6P
		sub [broty],dl
		jmp Bigloop
	Not6P:
		cmp ax,4838h
		jne Not8P
		sub [brotx],dl
		jmp Bigloop
	Not8P:
		cmp ax,5032h
		jne Not2P
		add [brotx],dl
		jmp Bigloop
	Not2P:
		cmp ax,4737h
		jne Not7P
		sub [brotz],dl
		jmp Bigloop
	Not7P:
		cmp ax,4939h
		jne Not9P
		add [brotz],dl
		jmp Bigloop
	Not9P:

		cmp ax,4c35h	;up (5)
		jne Not5P
		sub [bfptry],dx	;subtract kv
		jmp Bigloop
	Not5P:
		cmp ax,5230h	;down (0)
		jne Not0P
		add [bfptry],dx
		jmp Bigloop
	Not0P:
		cmp ax,4f31h	;left (1)
		jne Not1P
		sub [bfptrx],dx
		jmp Bigloop
	Not1P:
		cmp ax,5133h	;right (3)
		jne Not3P
		add [bfptrx],dx
		jmp Bigloop
	Not3P:
		cmp ax,4900h	;away (pgup)
		jne NotPGUPP
		add [bfptrz],dx
		jmp Bigloop
	NotPGUPP:
		cmp ax,5100h	;toward (pgdn)
		jne NotPGDNP
		sub [bfptrz],dx
		jmp Bigloop
	NotPGDNP:


		cmp ax,352fh	;decrease outline width
		jne Notslsh
		add [box],dx	;x1
		sub [box+6],dx	;x2
		sub [box+12],dx	;x3
		add [box+18],dx	;x4
		add [box+24],dx	;x5
		jmp Bigloop
	Notslsh:
		cmp ax,372ah	;increase outline width
		jne Notstar
		sub [box],dx	;x1
		add [box+6],dx	;x2
		add [box+12],dx	;x3
		sub [box+18],dx	;x4
		sub [box+24],dx	;x5
		jmp Bigloop
	Notstar:
		cmp ax,4a2dh	;decrease outline height
		jne NotMin
		add [box+2],dx	;y1
		add [box+8],dx	;y2
		sub [box+14],dx	;y3
		sub [box+20],dx	;y4
		add [box+26],dx	;y5
		jmp Bigloop
	NotMin:
		cmp ax,4e2bh	;increase outline height
		jne NotPlu
		sub [box+2],dx	;y1
		sub [box+8],dx	;y2
		add [box+14],dx	;y3
		add [box+20],dx	;y4
		sub [box+26],dx	;y5
		jmp Bigloop
	NotPlu:

	jmp Bigloop

;****************************************************************************
;ppstate - plotting state 2 - plotting points in the box
ppstate:
	;see if togling state
		cmp ax,011bh
		jne NotEscPP
		dec [state]
		jmp Bigloop
	NotEscPP:

		cmp ax,0f09h	;see if toggling hidden surface
		jne NotTabPP
		xor [hidden],1
		jmp Bigloop
	NotTabPP:
					;mouse pointer
		cmp ax,4b00h
		jne NotLPP
		sub [mpointerx],dx
		jmp Bigloop
	NotLPP:
		cmp ax,4d00h
		jne NotRPP
		add [mpointerx],dx
		jmp Bigloop
	NotRPP:
		cmp ax,4800h
		jne NotUPP
		sub [mpointery],dx
		jmp Bigloop
	NotUPP:
		cmp ax,5000h
		jne NotDPP
		add [mpointery],dx
		jmp Bigloop
	NotDPP:


	;see if plotted point
		cmp ax,3920h
		jne NotSpcPPP

		;get pointer to points + reset tx,ty,tz
		mov esi,fs:[(Object + edi).ToPolys]
		mov eax,dword ptr fs:[(Object + edi).xtrans]
		;mov bx,fs:[(Object + edi).ytrans]
		mov cx,fs:[(Object + edi).ztrans]
		mov dword ptr [tx],eax
		;mov [ty],bx
		mov [tz],cx

	;find the location at the end of the last poly & put pts there
		mov ax,fs:[(Object + edi).NumPolys]
		mov bx,SizeofPolyS
		dec ax
		mul bx
		shl edx,16
		mov dx,ax
		add edx,fs:[(Object + edi).ToPolys] ;edx has polygon address

		;find adress of new point location
		xor eax,eax
		mov al,fs:[(Polygon + edx).NumPoints]
		inc ax			;one more for loop
		mov cx,ax		;quicker than multiplying by 6
		shl ax,2		;""
		add ax,cx		;""
		add ax,cx		;""
		mov ebx,fs:[(Polygon + edx).ToPoints]
		add eax,ebx		;eax contains pointer to points

		;add on number of points worked on
		xor ebx,ebx
		mov bx,[plotyet]
		mov cx,bx
		shl bx,2
		add bx,cx
		add bx,cx
		add eax,ebx

		push eax

		;Don't draw line if first point
		cmp [plotyet],0
		je OnFirstPlot

		;now draw line to texture map (later can remove it?!)
		;need to test if can draw line - first point-can't
		mov bx,[foreground]
		mov [color],bx		;draw lines in foreground
			;find points
		mov bx,[mpointerx]
		mov cx,[mpointery]
		add bx,[box+6]
		add cx,[box+14]
		mov [pt1x],bx
		mov [pt1y],cx
		mov bx,fs:[eax-6]
		mov cx,fs:[eax-4]
		add bx,[box+6]
		add cx,[box+14]

		mov [pt2x],bx
		mov [pt2y],cx

		;find width & height
		mov ax,[box+6]
		mov bx,[box+20]
		sub ax,[box]
		sub bx,[box+2]
		mov [MapWidth],ax
		mov [MapHeight],bx
		mov edi,[ClrMap]
		call TMLine


	OnFirstPlot:
		inc [plotyet]

		mov bx,[mpointerx]
		mov cx,[mpointery]
		mov dx,[box+4]
		;store to array of points
		pop eax
		mov fs:[eax],bx
		mov fs:[eax+2],cx
		mov fs:[eax+4],dx

		;terminate string
		add eax,6
		mov word ptr fs:[eax],32000
		mov word ptr fs:[eax+2],32000
		mov word ptr fs:[eax+4],32000

		jmp Bigloop
	NotSpcPPP:

	;see if accepted polygon
		cmp ax,1c0dh
		jne NotEntPPP

		cmp [plotyet],1	;make sure more than 1 point was plotted
		jbe Bigloop

		;re-configure object
		mov edi,[NewObject]
		mov bx,fs:[(Object + edi).NumPolys]
		inc fs:[(Object + edi).NumPolys]	;add another poly
		mov edi,fs:[(Object + edi).ToPolys]	;get polys
		mov ax,SizeofPolyS
		mul bx
		shl edx,16
		mov dx,ax
		add edi,edx				;for last poly

		;copy ouline of poly (3&4 are swapped)
		mov al,[brotx]
		mov bl,[broty]
		mov dl,[brotz]
		mov [rotx],al
		mov [roty],bl
		mov [rotz],dl
		call RotSet


		mov ax,[box]
		mov bx,[box+2]
		mov dx,[box+4]
		add ax,[bfptrx]		;moving relative to rot point
		add bx,[bfptry]
		add dx,[bfptrz]
		mov [rx],ax
		mov [ry],bx
		mov [rz],dx
		call Rotate
		mov ax,[rx]
		mov bx,[ry]
		mov dx,[rz]
		add ax,[bpointerx]
		add bx,[bpointery]
		add dx,[bpointerz]
		mov fs:[(Polygon + edi).x1],ax
		mov fs:[(Polygon + edi).y1],bx
		mov fs:[(Polygon + edi).z1],dx
		mov [pt1x],ax	;store for normals
		mov [pt1y],bx
		mov [pt1z],cx

		mov ax,[box+6]
		mov bx,[box+8]
		mov dx,[box+10]
		add ax,[bfptrx]		;moving relative to rot point
		add bx,[bfptry]
		add dx,[bfptrz]
		mov [rx],ax
		mov [ry],bx
		mov [rz],dx
		call Rotate
		mov ax,[rx]
		mov bx,[ry]
		mov dx,[rz]
		add ax,[bpointerx]
		add bx,[bpointery]
		add dx,[bpointerz]
		mov fs:[(Polygon + edi).x2],ax
		mov fs:[(Polygon + edi).y2],bx
		mov fs:[(Polygon + edi).z2],dx
		mov [pt2x],ax	;store for normals
		mov [pt2y],bx
		mov [pt2z],cx

		mov ax,[box+12]
		mov bx,[box+14]
		mov dx,[box+16]
		add ax,[bfptrx]		;moving relative to rot point
		add bx,[bfptry]
		add dx,[bfptrz]
		mov [rx],ax
		mov [ry],bx
		mov [rz],dx
		call Rotate
		mov ax,[rx]
		mov bx,[ry]
		mov dx,[rz]
		add ax,[bpointerx]
		add bx,[bpointery]
		add dx,[bpointerz]
		mov fs:[(Polygon + edi).x4],ax
		mov fs:[(Polygon + edi).y4],bx
		mov fs:[(Polygon + edi).z4],dx

		mov ax,[box+18]
		mov bx,[box+20]
		mov dx,[box+22]
		add ax,[bfptrx]		;moving relative to rot point
		add bx,[bfptry]
		add dx,[bfptrz]
		mov [rx],ax
		mov [ry],bx
		mov [rz],dx
		call Rotate
		mov ax,[rx]
		mov bx,[ry]
		mov dx,[rz]
		add ax,[bpointerx]
		add bx,[bpointery]
		add dx,[bpointerz]
		mov fs:[(Polygon + edi).x3],ax
		mov fs:[(Polygon + edi).y3],bx
		mov fs:[(Polygon + edi).z3],dx
		mov [pt3x],ax	;store for normals
		mov [pt3y],bx
		mov [pt3z],cx

		call FindXNormal		;find all normals
		mov [Xa],ecx
		call FindYNormal
		mov [Ya],ecx
		call FindZNormal
		mov [Za],ecx

		mov eax,[Xa]		;find sum of squares of normals
		imul eax
		mov ebx,eax
		mov eax,[Ya]
		imul eax
		add ebx,eax
		mov eax,ecx
		imul eax
		add eax,ebx
		push edi
		call SQRT			;square root (3-d distance)
		pop edi
		mov ebx,eax

		mov eax,[Xa]		;normalize
		mov edx,eax			;8 bit decimal
		sar edx,24
		shl eax,8
		idiv ebx			;divide to normalize
		;neg ax
		mov fs:[(Polygon + edi).normx],ax	;store

		mov eax,[Ya]
		mov edx,eax
		sar edx,24
		shl eax,8
		idiv ebx
		;neg ax
		mov fs:[(Polygon + edi).normy],ax

		mov eax,[Za]
		mov edx,eax
		sar edx,24
		shl eax,8
		idiv ebx
		neg ax		;flip z
		mov fs:[(Polygon + edi).normz],ax

		cmp ax,0	;negate if facing away
		jge znegm
		neg fs:[(Polygon + edi).normy]
	znegm:

		mov ax,[box+6]
		mov bx,[box+20]
		sub ax,[box]
		sub bx,[box+2]
		mov fs:[(Polygon + edi).numlpix],ax
		mov fs:[(Polygon + edi).numhpix],bx

		mul bx		;find length of area of polygon
		shl edx,16	;put together
		push edi	;save for later - need for clearing
		mov dx,ax
		shl edx,1	;2bytes/pixel
		mov esi,[NewObject]	;get for addresses
		add edx,128		;give it some room
		mov ecx,edx		;store into counter
		mov edi,edx
		add edx,fs:[esi+52]	;add onto regular address
		mov edi,fs:[esi+52]
		mov eax,edi		;save location for texture map
		mov fs:[esi+52],edx	;store for next polygon
		pop edi			;location to object
		mov fs:[(Polygon + edi).ToMap],eax

		;get pointer to points for rotation/translation
		xor eax,eax		;clear
		sub edi,SizeofPolyS	;go to 2nd last poly
		mov al,fs:[(Polygon + edi).NumPoints]
		inc ax			;one more for loop
		mov cx,ax		;quicker than multiplying by 6
		shl ax,2		;""
		add ax,cx		;""
		add ax,cx		;""
		mov ebx,fs:[(Polygon + edi).ToPoints]
		add eax,ebx		;eax contains pointer to points
		add edi,SizeofPolyS	;go to new poly
		mov fs:[(Polygon + edi).ToPoints],eax

		;translate points - rotset is still pre-set correctly
		xor ecx,ecx
		mov esi,eax
		mov [temp],0
;		mov edi,[PtBfr]
	transloop:
		mov ax,fs:[esi+ecx]
		mov bx,fs:[esi+ecx+2]
		mov dx,fs:[esi+ecx+4]
		add ax,[bfptrx]		;moving relative to rot point
		add bx,[bfptry]
		add dx,[bfptrz]
		mov [rx],ax
		mov [ry],bx
		push ecx
		mov [rz],dx
		call Rotate
		mov ax,[rx]
		pop ecx
		mov bx,[ry]
		mov dx,[rz]
		add ax,[bpointerx]
		add bx,[bpointery]
		add dx,[bpointerz]
		mov fs:[esi+ecx],ax
		mov fs:[esi+ecx+2],bx
		mov fs:[esi+ecx+4],dx
		add ecx,6
		inc [temp]
		mov ax,[plotyet]
		cmp [temp],ax
		jb transloop

		;find number of points
		mov ax,[plotyet]	;variable used while plotting
		dec ax			;assume that the last point connects
		mov [plotyet],0		;reset
		mov fs:[(Polygon + edi).NumPoints],al	;store number
		mov bl,[hidden]
		mov fs:[(Polygon + edi).Flags],bl	;flags

		;copy texturemap
		push es	;fixed at end
		push fs
		pop es
		mov esi,[ClrMap]
		mov edi,fs:[(Polygon + edi).ToMap]
		;find dimentions
		mov ax,[box+6]
		mov bx,[box+20]
		sub ax,[box]
		sub bx,[box+2]
		mul bx		;take width x height
		shl edx,16
		mov dx,ax
		shl edx,1	;2bytes/pixel
		mov ecx,edx
		add ecx,128	;just to be safe
		shr ecx,2	;divide by 4
		push ds
		push fs
		pop ds
	    rep movsd
		pop ds


		;clear buffers
		mov ecx,4000h
		mov eax,08210821h
		mov edi,[ClrMap]
	    rep stosd
		pop es

		mov [state],0	;Reset state

	NotEntPPP:
jmp Bigloop

;****************************************************************************
;pbstate	- state for plotting sides of special 4 pt poly (flex)
pbstate:
	;see if togling state
		cmp ax,011bh		;see if going to normal poly
		jne NotSPB
		sub [state],2
		mov word ptr [box],-30
		mov word ptr [box+2],-30
		mov word ptr [box+4],0
		mov word ptr [box+6],30
		mov word ptr [box+8],-30
		mov word ptr [box+10],0
		mov word ptr [box+12],30
		mov word ptr [box+14],30
		mov word ptr [box+16],0
		mov word ptr [box+18],-30
		mov word ptr [box+20],30
		mov word ptr [box+22],0
		mov word ptr [box+24],-30
		mov word ptr [box+26],-30
		mov word ptr [box+28],0
		jmp Bigloop
	NotSPB:


		cmp ax,0f09h	;see if toggling hidden surface
		jne NotTabPPB
		xor [hidden],1
		jmp Bigloop
	NotTabPPB:


		cmp ax,1970h	;p button - for toggling thru points
		jne NotPPB
		inc [fpointon]
		and [fpointon],00000011b ;clear upper (1-4 only)
		jmp Bigloop
	NotPPB:

			;next 6 move point around
			;setup for points (addressing)
			xor ebx,ebx
			mov bx,[fpointon]
			shl bx,1	;mul by 6 (mul by 2)
			mov cx,bx	;store 2*num
			shl bx,1	;mul by 2
			add bx,cx	;add 4*num to 2*num
		;for toggling through points
		include toggle.inc

		cmp ax,4b00h
		jne NotLPB		;x
		sub [nextbox+ebx],dx
		cmp [fpointon],0	;incase it's the first point
		jne Bigloop
		sub [nextbox+ebx+24],dx
		jmp Bigloop
	NotLPB:
		cmp ax,4d00h
		jne NotRPB
		add [nextbox+ebx],dx	;x
		cmp [fpointon],0	;incase it's the first point
		jne Bigloop
		add [nextbox+ebx+24],dx
		jmp Bigloop
	NotRPB:
		cmp ax,4800h
		jne NotUPB
		sub [nextbox+ebx+2],dx	;y
		cmp [fpointon],0	;incase it's the first point
		jne Bigloop
		sub [nextbox+ebx+26],dx
		jmp Bigloop
	NotUPB:
		cmp ax,5000h
		jne NotDPB
		add [nextbox+ebx+2],dx	;y
		cmp [fpointon],0	;incase it's the first point
		jne Bigloop
		add [nextbox+ebx+26],dx
		jmp Bigloop
	NotDPB:
		cmp ax,4700h
		jne NotHPB
		add [nextbox+ebx+4],dx	;z
		cmp [fpointon],0	;incase it's the first point
		jne Bigloop
		add [nextbox+ebx+28],dx
		jmp Bigloop
	NotHPB:
		cmp ax,4f00h
		jne NotEPB
		sub [nextbox+ebx+4],dx	;z
		cmp [fpointon],0	;incase it's the first point
		jne Bigloop
		sub [nextbox+ebx+28],dx
		jmp Bigloop
	NotEPB:

		cmp ax,4e2bh		;increase y resolution
		jne NotPlusPB
		cmp [fyres],512
		jae Bigloop
		inc [fyres]
		jmp Bigloop
	NotPlusPB:
		cmp ax,4a2dh		;dec y res
		jne NotMinPB
		cmp [fyres],1
		jbe Bigloop
		dec [fyres]
		jmp Bigloop
	NotMinPB:
		cmp ax,372ah		;inc x res
		jne NotStarPB
		cmp [fxres],512
		jae Bigloop
		inc [fxres]
		jmp Bigloop
	NotStarPB:
		cmp ax,352fh		;dec x res
		jne NotSlshPB
		cmp [fxres],1
		jbe Bigloop
		dec [fxres]
		jmp Bigloop
	NotSlshPB:

		;see if accepted polygon
		cmp ax,1c0dh
		jne NotEntPB

		mov edi,[NewObject]
		mov bx,fs:[(Object + edi).NumPolys]
		inc fs:[(Object + edi).NumPolys]
		mov edi,fs:[(Object + edi).ToPolys]
		mov ax,SizeofPolyS
		mul bx			;multiply for number of polys
		shl edx,16
		mov dx,ax
		add edi,edx		;for last poly

		;now copy polygon border
		mov eax,dword ptr [nextbox]
		mov bx,[nextbox+4]
		mov dword ptr fs:[(Polygon + edi).x1],eax
			mov dword ptr [pt1x],eax	;store these for normals
		mov fs:[(Polygon + edi).z1],bx
			mov [pt1z],bx
		mov eax,dword ptr [nextbox+6]
		mov bx,[nextbox+10]
		mov dword ptr fs:[(Polygon + edi).x2],eax
			mov dword ptr [pt2x],eax
		mov fs:[(Polygon + edi).z2],bx
			mov [pt2z],bx
		mov eax,dword ptr [nextbox+18]
		mov bx,[nextbox+22]	;3 & 4 are swapped between the 2
		mov dword ptr fs:[(Polygon + edi).x3],eax
			mov dword ptr [pt3x],eax
		mov fs:[(Polygon + edi).z3],bx
			mov [pt3z],bx
		mov eax,dword ptr [nextbox+12] ;3 & 4 are swapped
		mov bx,[nextbox+16]
		mov dword ptr fs:[(Polygon + edi).x4],eax
		mov fs:[(Polygon + edi).z4],bx

		call FindXNormal		;find all normals
		mov [Xa],ecx
		call FindYNormal
		mov [Ya],ecx
		call FindZNormal
		mov [Za],ecx

		mov eax,[Xa]		;find sum of squares of normals
		imul eax
		mov ebx,eax
		mov eax,[Ya]
		imul eax
		add ebx,eax
		mov eax,ecx
		imul eax
		add eax,ebx
		push edi
		call SQRT			;square root (3-d distance)
		pop edi
		mov ebx,eax

		mov eax,[Xa]		;normalize
		mov edx,eax			;8 bit decimal
		sar edx,24
		shl eax,8
		idiv ebx			;divide to normalize
		;neg ax
		mov fs:[(Polygon + edi).normx],ax	;store

		mov eax,[Ya]
		mov edx,eax
		sar edx,24
		shl eax,8
		idiv ebx
		;neg ax
		mov fs:[(Polygon + edi).normy],ax

		mov eax,[Za]
		mov edx,eax
		sar edx,24
		shl eax,8
		idiv ebx
		neg ax		;flip z
		mov fs:[(Polygon + edi).normz],ax

		cmp ax,0	;negate if facing away
		jge zneg
		neg fs:[(Polygon + edi).normy]
	zneg:


		mov ax,[fxres]		;store resolution
		mov bx,[fyres]
		mov fs:[(Polygon + edi).numlpix],ax
		mov fs:[(Polygon + edi).numhpix],bx

		mul bx		;find length of area of polygon
		shl edx,16	;put together
		push edi	;save for later - need for clearing
		mov dx,ax
		shl edx,1	;2bytes/pixel
		mov esi,[NewObject]	;get for addresses
		add edx,128		;give it some room
		mov ecx,edx		;store into counter
		mov edi,edx
		shr ecx,2
		add edx,fs:[esi+52]	;add onto regular address
		mov edi,fs:[esi+52]
		mov eax,edi		;save location for texture map
		mov fs:[esi+52],edx	;store for next polygon
		pop edi			;location to object
		mov fs:[(Polygon + edi).ToMap],eax


		;add on new points
		xor eax,eax		;clear
		sub edi,SizeofPolyS	;go to 2nd last poly
		mov al,fs:[(Polygon + edi).NumPoints]
		inc ax			;add on necesary point
		shl ax,1		;quick multiply by 6
		mov bx,ax
		shl ax,1
		add ax,bx		;" "
		add eax,fs:[(Polygon + edi).ToPoints]
		add edi,SizeofPolyS
		mov fs:[(Polygon + edi).ToPoints],eax

		mov esi,eax		;esi has address to new points
		;begin copying
		mov eax,dword ptr [nextbox]
		mov ebx,dword ptr [nextbox+4]
		mov fs:[esi],eax
		mov fs:[esi+4],ebx
		mov eax,dword ptr [nextbox+8]
		mov ebx,dword ptr [nextbox+12]
		mov fs:[esi+8],eax
		mov fs:[esi+12],ebx
		mov eax,dword ptr [nextbox+16]
		mov ebx,dword ptr [nextbox+20]
		mov fs:[esi+16],eax
		mov fs:[esi+20],ebx
		mov eax,dword ptr [nextbox+24]
		mov bx,[nextbox+28]
		mov fs:[esi+24],eax
		mov fs:[esi+28],bx
		mov word ptr fs:[esi+30],32000	;terminate string of points
		mov word ptr fs:[esi+32],32000
		mov bl,[hidden]
		mov word ptr fs:[esi+34],32000

		mov fs:[(Polygon + edi).Flags],bl	;flags

		mov fs:[(Polygon + edi).NumPoints],4


		;store texturemap
		push es
		push fs
		pop es
		mov edi,fs:[(Polygon + edi).ToMap]
		mov ax,[fxres]
		mov bx,[fyres]
		mul bx
		shl edx,16
		mov dx,ax
		shl edx,1	;2bytes/pixel
		mov ecx,edx
		shr ecx,2
		mov eax,84108410h
	    rep stosd
		mov ecx,128		;some breathing room
		mov eax,08210821h
	    rep stosd
		pop es



;- make it map yellow init?
		mov [state],0
	NotEntPB:


jmp NotE	;jump to rotation - same as state 0
jmp Bigloop

fpointon dw (?)



;****************************************************************************
;tmstate	- state for pre-editting texture maps - with tools, etc.
tmstate:

		cmp ax,0f09h	;tab
		je TabTM
		cmp ax,011bh	;esc
		jne NotTabTM
	 TabTM:
		mov [state],0	;go back to original state
		jmp Bigloop
	NotTabTM:

		cmp ax,1c0dh	;see if editing
		jne NotEntTM
		mov [state],5
		mov [gencount],0
		jmp Bigloop
	NotEntTM:

		cmp ax,1970h	;cycle through polygons
		jne NotPTM
		inc [OnPoly]
		mov ax,fs:[(Object + edi).NumPolys]
		cmp [OnPoly],ax	;if get to last one, start over
		jne Bigloop
		mov [OnPoly],0
		jmp Bigloop
	NotPTM:


		cmp ax,4b00h
		jne NotLTM
		sub [tmeditat],dx
		jmp Bigloop
	NotLTM:
		cmp ax,4d00h
		jne NotRTM
		add [tmeditat],dx
		jmp Bigloop
	NotRTM:
		cmp ax,4800h
		jne NotUTM
		sub [tmeditat+2],dx
		jmp Bigloop
	NotUTM:
		cmp ax,5000h
		jne NotDTM
		add [tmeditat+2],dx
		jmp Bigloop
	NotDTM:

		cmp ax,4e2bh		;increase resolution
		jne NotPlusTM
		add [tmeditat+4],dx
		jmp Bigloop
	NotPlusTM:
		cmp ax,4a2dh		;dec res
		jne NotMinTM
		sub [tmeditat+4],dx
		jmp Bigloop
	NotMinTM:

	;tools:
		cmp ax,5300h		;del (Polygon)
		jne NotDelTM

		mov cx,fs:[(Object + edi).NumPolys];get num polys
		cmp cx,2
		jbe Bigloop
		mov ax,[OnPoly]		;get poly selected
		mov esi,fs:[(Object + edi).ToPolys];get polys
		dec cx			;one less polygon then listed
		mov fs:[(Object + edi).NumPolys],cx ;store 1 less poly
		mov bx,SizeofPolyS
		sub cx,ax		;find number of polys need to move
		mul bx			;find address of deleting poly
		shl edx,16
		mov dx,ax
		push es			;get selector
		push fs			;get selector
		pop es			;get selector
		add esi,edx		;start location of poly
		mov edi,esi		;get start location
		push ds
		push fs
		pop ds
		mov dx,cx		;store counter (# polys)
		add esi,SizeofPolyS	;get next polygon
		inc dx			;move one more (just in case)
	  DelTMLoop:
		mov ecx,19		;for moving by words - SizeofPolyS/2
	    rep movsw			;move 
		dec dx
		cmp dx,0		;if not done, do again
		jne DelTMLoop

		pop ds			;reset stuff
		pop es
		mov [OnPoly],0
	NotDelTM:

jmp Bigloop

OnPoly dw (0)	;polygon that it's currently on - need to change to 1
		;after removing cube (need invisible poly)

;****************************************************************************
;editstate	- state for editting texture maps
Editstate:

		cmp ax,011bh	;esc
		jne NotEscEd
		mov [state],4
		call InitMouse
		jmp Bigloop
	 NotEscEd:

;to move cursor, get colors, and plot colors
;in dsiptme, draw an overlay of the mouse map, in the same resolution
;as the background

		cmp ax,4b00h
		jne NotLTME
		sub [tmex],dx
		cmp [tmex],0
		jle FixLE
		jmp Bigloop
	  FixLE:
		mov [tmex],0
		jmp Bigloop
	NotLTME:

		;get up,down,left,right
		cmp ax,4d00h
		jne NotRTME
		add [tmex],dx
		mov bx,[clen]
		cmp [tmex],bx
		jae FixRE
		jmp Bigloop
	   FixRE:
		dec bx
		mov [tmex],bx
		jmp Bigloop
	NotRTME:
		cmp ax,4800h
		jne NotUTME
		sub [tmey],dx
		cmp [tmey],0
		jle FixUE
		jmp Bigloop
	   FixUE:
		mov [tmey],0
		jmp Bigloop
	NotUTME:
		cmp ax,5000h
		jne NotDTME
		cmp [tmey],256
		jae Bigloop
		add [tmey],dx
		mov bx,[cheight]
		cmp [tmey],bx
		jae FixDE
		jmp Bigloop
	   FixDE:
		dec bx
		mov [tmey],bx
		jmp Bigloop
	NotDTME:

	;done with movement



   ;---Drawing Utilities-----------------------------------
	;color switching
		cmp ax,2e63h	;color (c)	-cycle through color points
		jne NotCTME
		inc [ColPt]
		cmp [ColPt],3
		jne Bigloop
		mov [ColPt],0
		jmp Bigloop
	NotCTME:

	;incrementing color
		cmp ax,4e2bh		;aweful but fast way to increment
		jne NotPlTME		;one part of the color argb
	  PlTME:
		cmp [ColPt],0
		jne notredi
		mov ax,[OnColor]
		shr ax,11
		add ax,dx
		and ax,11111b
		shl ax,11
		and [OnColor],0000011111111111b
		or [OnColor],ax
		jmp Bigloop

	notredi:
		cmp [ColPt],1
		jne notgreeni
		mov ax,[OnColor]
		shr ax,5
		add ax,dx
		and ax,111111b
		shl ax,5
		and [OnColor],1111100000011111b
		or [OnColor],ax
		jmp Bigloop

	notgreeni:
		cmp [ColPt],2	;blue
		jne Bigloop
		mov ax,[OnColor]
		add ax,dx
		and ax,011111b
		and [OnColor],1111111111100000b
		or [OnColor],ax
		jmp Bigloop
	NotPlTME:

		cmp ax,4a2dh	;see if decremented color
		jne NotMiTME
		neg dx
		jmp PlTME
	NotMiTME:

		cmp ax,3920h	;see if plotted point
		jne NotSpcTME
	  KBPlotPoint:
		push ax
		mov edi,[cMap]	;get address of tm - defined in Disptm.inc
		mov bx,[tmey]
		mov ax,[clen]	;stored from earlier - Disptm.inc
		mul bx		;multiply pixlen (ax) by tmey
		shl edx,16
		add ax,[tmex]	;add on x value
		mov dx,ax	;adjust into edx
		shl edx,1	;2bytes/pixel
		mov cx,[OnColor]
		add edi,edx	;add onto base
		mov fs:[edi],cx	;store color
		pop ax
		cmp ax,1234
		jne Bigloop
		ret
	NotSpcTME:


		cmp ax,256bh	;k: see if started line again
		jne NotkTME
		mov ax,[tmex] ;load point now into line starts
		mov bx,[tmey]
		mov [lxstart],ax
		mov [lystart],bx
		jmp Bigloop
	NotkTME:

		cmp ax,266ch	;l: see if drawing line
		jne NotlTME
		mov edi,[cMap]
		mov ax,[clen]
		mov bx,[cheight]
		mov [MapWidth],ax
		mov [MapHeight],bx

		;load points
		mov ax,[lxstart] ;defined either with k, or last time
		mov bx,[lystart]
		mov [pt1x],ax
		mov [pt1y],bx
		mov ax,[tmex]
		mov bx,[tmey]
		mov [pt2x],ax
		mov [pt2y],bx
		mov [lxstart],ax	;store points for next line
		mov [lystart],bx

		mov ax,[OnColor]	;use this color
		mov [color],ax

		call TMLine

		jmp Bigloop
	NotlTME:


		cmp ax,342eh		;  .	-for filling in areas
		jne NotPdTME

		;calculate maximum length
		mov ax,[clen]
		mov bx,[cheight]
		mul bx
		shl edx,16
		mov dx,ax
		mov [cmax],edx

		mov edi,[cMap]	;get address of tm - defined in Disptm.inc
		mov bx,[tmey]
		mov ax,[clen]	;stored from earlier - Disptm.inc
		mul bx		;multiply pixlen (ax) by tmey
		shl edx,16
		add ax,[tmex]	;add on x value
		mov esi,edi	;make copy
		mov dx,ax	;adjust into edx
		shl edx,1	;2bytes/pixel
		add esi,edx	;add onto base
		mov ax,fs:[esi]
		mov [color],ax	;store compair color
				;OnColor is the placing color

		cmp [OnColor],ax ;just in case it is the same color
		je Bigloop		;to prevent errors

		xor ecx,ecx
		mov bx,[OnColor] ;bx=color to put, ax=color to overwrite
		mov cx,[clen]
		shl ecx,1

		shl [cmax],1
		call FillArea
		shr [cmax],1

		jmp Bigloop
	NotPdTME:

	;see if importing a pcx file
		cmp ax,320dh
		jne NotCtrlM
		include opentm.inc
		jmp Bigloop
	NotCtrlM:

jmp Bigloop



;****************************************************************************
;Lightstate	- state for adjusting the light source
Lightstate:

		cmp ax,011bh	;esc
		jne NotEscL
		mov [state],0
		jmp AdjL
	 NotEscL:

		cmp ax,4b34h
		jne Not4L
		add [lroty],dl
		jmp AdjL
	Not4L:
		cmp ax,4d36h
		jne Not6L
		sub [lroty],dl
		jmp AdjL
	Not6L:
		cmp ax,4838h
		jne Not8L
		sub [lrotx],dl
		jmp AdjL
	Not8L:
		cmp ax,5032h
		jne Not2L
		add [lrotx],dl
		jmp AdjL
	Not2L:
		cmp ax,4737h
		jne Not7L
		sub [lrotz],dl
		jmp AdjL
	Not7L:
		cmp ax,4939h
		jne Not9L
		add [lrotz],dl
		jmp AdjL
	Not9L:

	jmp Bigloop


AdjL:
	mov eax,dword ptr [lrotx]
	mov dword ptr [rotx],eax
	call RotSet

	mov eax,dword ptr [lightix]
	mov bx,[lightiz]
	mov dword ptr [rx],eax
	mov [rz],bx
	call Rotate
	mov eax,dword ptr [rx]
	mov bx,[rz]
	mov dword ptr [lightx],eax
	mov [lightz],bx

	jmp Bigloop

;****************************************************************************

;Clears mouse buffer and re-plots mouse
updatemptr proc
	;clear up front buffer
	mov eax,08210821h
	mov ecx,65536*2
	push es
	push fs
	pop es
	mov edi,[ClrMouse]
	cld
     rep stosd
	pop es

	;find points for mouse
	xor eax,eax
	mov ax,[box+20]
	sub ax,[box+2]
	mov bx,ax
	shr ax,1
	add ax,[mpointery]
	cmp ax,0
	jle eupdptr
	cmp ax,bx
	jge eupdptr

	xor ecx,ecx
	mov bx,[box+6]
	sub bx,[box]
	mov cx,bx
	shr bx,1
	add bx,[mpointerx]
	cmp bx,0
	jle eupdptr
	cmp bx,cx
	jge eupdptr

	;plot mouse points
	mul cx
	add ax,bx
	mov edi,[ClrMouse]
	mov dx,[foreground]
	mov word ptr fs:[edi+2*eax],dx
	mov word ptr fs:[edi+2*eax+2],dx
	mov word ptr fs:[edi+2*eax-2],dx
	add eax,ecx
	mov word ptr fs:[edi+2*eax],dx
	sub eax,ecx
	sub eax,ecx
	mov word ptr fs:[edi+2*eax],dx

 eupdptr:
	ret
ENDP

;edx = offset in addition to fs:edi - (constant) the start of the map
;ax is color to fill, color is the color to check for
FillArea proc
	mov esi,edi	;make copy of destination
	add esi,edx	;find location

	mov fs:[esi],bx

	cmp edx,2		;check to left
	jl SA
	cmp fs:[esi-2],ax	;see if overwriting
	jne SA
	mov fs:[esi-2],bx	;color to put
	push esi		;save stuff
	sub edx,2
	call FillArea
	add edx,2		;restore stuff
	pop esi
  SA:

	cmp [cmax],edx		;check to right
	jbe SD
	cmp fs:[esi+2],ax	;see if overwriting
	jne SD
	mov fs:[esi+2],bx	;color to put
	push esi		;save stuff
	add edx,2
	call FillArea
	sub edx,2		;restore stuff
	pop esi
  SD:


	cmp [cmax],edx		;check below
	jb SX
	cmp fs:[esi+ecx],ax	;see if overwriting
	jne SX
	mov fs:[esi+ecx],bx	;color to put
	push esi		;save stuff
	add edx,ecx
	call FillArea
	sub edx,ecx		;restore stuff
	pop esi
  SX:

	cmp ecx,edx		;check above
	ja SW
	neg ecx
	cmp fs:[esi+ecx],ax	;see if overwriting
	jne SW
	mov fs:[esi+ecx],bx	;color to put
	add edx,ecx		;save stuff
	push esi
	neg ecx
	call FillArea
	neg ecx
	pop esi
	sub edx,ecx		;restore stuff
  SW:
	neg ecx

	ret
ENDP